"""

Few rules:
    1. IMPORTANT: Start all loggers in scripts this way:
        import logging
        logger=getLogger("__main__")
    This will ensure that I can maintain control over logging levels, formatters etc across everything!

Update: 26 August 2018: With the creation of the loggerMain module it should be possible to setup logging with very
little effort.

"""

import logging


keyWordsForLogging="""

Allowed keywords for string format:
    asctime= "%(asctime)s"
    logCreatedTime= "%(created)f"
    fileName= "%(filename)s"
    funcName= "%(funcName)s"
    levelName= "%(levelname)s"
    levelNumber= "%(levelno)s"
    lineNumber= "%(lineno)d"
    moduleName= "%(module)s"
    millisecondsCreated= "%(msecs)d"
    message= "%(message)s"
    loggerName= "%(name)s"
    pathName= "%(pathname)s"
    processID= "%(process)d"
    processName= "%(processName)s"
    relativeCreationTime= "%(relativeCreated)d"
    threadID= "%(thread)d"
    threadName= "%(threadName)s"
    
    
Allowed keywords for creatingTime:
    %a 	Locale's abbreviated weekday name.
    %A 	Locale's full weekday name.
    %b 	Locale's abbreviated month name.
    %B 	Locale's full month name.
    %c 	Locale's appropriate date and time representation.
    %d 	Day of the month as a decimal number [01,31].
    %H 	Hour (24-hour clock) as a decimal number [00,23].
    %I 	Hour (12-hour clock) as a decimal number [01,12].
    %j 	Day of the year as a decimal number [001,366].
    %m 	Month as a decimal number [01,12].
    %M 	Minute as a decimal number [00,59].
    %p 	Locale's equivalent of either AM or PM. 	(1)
    %S 	Second as a decimal number [00,61]. 	(2)
    %U 	Week number of the year (Sunday as the first day of the week) as a decimal number
        [00,53]. All days in a new year preceding the first Sunday are considered to be in week 0.
    %w 	Weekday as a decimal number [0(Sunday),6].
    %W 	Week number of the year (Monday as the first day of the week) as a decimal number
        [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.
    %x 	Locale's appropriate date representation.
    %X 	Locale's appropriate time representation.
    %y 	Year without century as a decimal number [00,99].
    %Y 	Year with century as a decimal number.
    %Z 	Time zone name (no characters if no time zone exists).
    %% 	A literal '%' character.
"""


def simplestLoggerForMainScript():

    #Note that this should only be applied to
    import logging

    logger = logging.getLogger("__main__")
    streamHandler = logging.StreamHandler()
    formatter = logging.Formatter(
        '%(asctime)s - %(name)s - %(levelname)s - %(message)s',
        "%Y-%m-%d %H:%M:%S")
    streamHandler.setFormatter(formatter)
    logger.addHandler(streamHandler)
    logger.setLevel(logging.DEBUG)

    logger.debug("This is a debug message!")
    logger.critical("This is an error!")



def formatterExamples():
    #Hour-Month-Sec,Logging Level, Module, Function, Line Number
    formatter = logging.Formatter(
        '%(asctime)s %(levelname)s: Mod-%(module)s Func-%(funcName)s Line-%(lineno)d',"%H:%M:%S")


#simpleExample()
