


def createVariables(varList, valList=None, addSelf=True, addSomethingElse=None,
                    varPrefix="", varSuffix="", valPrefix='', valSuffix=''):
    """
    This is a hacky "factory" function that will create a line of varibles and values that can be used to create python
    code. See examples below.
    :param varList: A list or tuple containing strings that are to be named as variables.
    :param valList: A list or tuple containing strings of values corresponding to the variables. If not provided, the
        same names of variables will be assigned as values.
    :param addSelf: Add a 'self.' before the name of the variable.
    :param addSomethingElse: Add a 'something.' before the name of the variable, where "something" is the value assigned
        to this parameter.
    :param varPrefix: Add a prefix before the name of the variable.
    :param varSuffix: Add a suffix after the name of the variable.
    :param valPrefix: Add a prefix before the value.
    :param valSuffix: Add a suffix after the value.
    :return: A string with line break containin the variables.
    Usage:
    createVariables(["Cuba","Japan","France"])
        self.Cuba='Cuba'
        self.Japan='Japan'
        self.France='France'
    createVariables(["Cuba","Japan","France"],['CU','JA',FR'])
        self.Cuba='CU'
        self.Japan='JA'
        self.France='FR'
    createVariables(range(3),varPrefix="var",valSuffix="_num")
        self.var0='0_num'
        self.var1='1_num'
        self.var2='2_num'
    """
    className=""
    if addSelf:
        className="self."
    if addSomethingElse:
        className = "%s."%addSomethingElse

    if valList:
        assert len(valList)==len(varList), "The size of the list variable and list of values must be same"
    else:
        valList=list(varList)
    newString=""

    for idx,var in enumerate(varList):
        newString+="%s%s%s%s = '%s%s%s'\n"%(className,varPrefix,var,varSuffix,valPrefix,valList[idx],valSuffix)

    return newString

def createVariableFromInit():
    """
    Leaving this here to remind myself that trying to create this function is a waste of
    time!!!

    I tried to get this to work over a period of two days and didnt make much of a headway.
    """

    pass

def createInitFromWords(lst,defaultVal=None, lineLengthLimit=60):
    """
    Given a list of words, create an init function.

    If the defaultVal is None then assign the values for each variable as None. If the default value
    is a sequnce, such as a list or a tuple, then first check if the sequence is of the
    same length as the lst, and then assign the variable values in sequence.
    Note that strings need to be specifed as '"someString"' and so on. If a value is specified
    as '(1,2,3)' then that will be assumed to be a tuple.

    :param lst:
    :param defaultVal:
    :param className:

    :return:

    """



    if defaultVal:
        assert type(defaultVal) in (list,tuple),\
            "The defaultVal if specified must be a list or a tuple containing the values for individual variables"

        assert len(defaultVal)== len(lst),\
            "The lengths of the lst(%s) and defaultVal(%s) must be same."%(len(lst),len(defaultVal))

    else:
        defaultVal=[None]*len(lst)

    initStart = """def __init__ (self, """
    initStartLen=len(initStart)
    currentStr=""

    for idx,val in enumerate(lst):
        varStr="%s = %s, "%(val,defaultVal[idx])
        if len(currentStr)<lineLengthLimit:
            initStart+=varStr
            currentStr+=varStr
        else:
            initStart+=" \n %s%s"%(" "*initStartLen,varStr)
            currentStr=varStr

    initStart=initStart[:-2]+" ):"

    return initStart

