"""
The idea of this module is to create
"""

uniCodeDictionary = {'\xe2\x88\x92':'-',
                     '\xe2\x80\x99':"'",
                     '\xe2\x80\x98':"'",
                     '\xcb\x9c':"~",
                     '\xcb\x86':"^",
                     '\xc2\xb0':" degrees",
                     '\xc2\xb1':"+/-",
                     '\xc2\xb2':"^2",
                     '\xc2\xb3':'^3'}

def resizeString(strings,lineSize=80,expectedHeadingLen = 30,checkForFullStops=True):
    """
    Args:
        strings:Can be any string that needs to be formmated. Best option
                      would be to write that in scrap.txt and read from there.
        lineSize: int .The line character width at which the line needs to be
                       truncated.
        expectedHeadingLen: int. Some lines can just be headings like "-ab". So
                                 any line below this len will be classified as
                                 a heading.
        checkForFullStops: bool. Boolean value to check if a heading is a line
                                or a part of a sentence.
    Returns:
        str. The formatted string as per the options.
    """

    if isinstance(strings,str):
        strings = [strings]

    for string in strings:
        for keys in uniCodeDictionary:
            string = string.replace(keys,uniCodeDictionary[keys])
        stringVal = string.strip().split('\n')

        stringVal = [val.strip() for val in stringVal if not val.startswith('\t')
                    and len(val)>0  and not len(val.strip())/len(val) <0.4]

        stringVal = [sentence.split() for sentence in stringVal]
        outputString = []
        tempString = ''

        for idx,sentence in enumerate(stringVal):
            if (len(" ".join(sentence)) < expectedHeadingLen) and (checkForFullStops is True) \
                    and not " ".join(sentence).endswith("."):
                tempString += "\n\n%s\n"%(" ".join(sentence))
                outputString.append(tempString)
                tempString = ''
            else:
                if not sentence and idx != (len(stringVal)-1):
                    outputString.append(tempString)
                    if tempString:
                        outputString.append('')
                    tempString = ''
                else:
                    for words in sentence:
                        if len(tempString)+len(words)<=lineSize:
                            if tempString:
                                tempString += " %s"%words
                            else:
                                tempString += words
                        else:
                            outputString.append(tempString)
                            tempString = words

        outputString.append(tempString)

        return "\n".join(outputString).strip()

def printStringIndented(stringVal,indent,stringPrefix="",stringSuffix=""):
    """
    As the title suggests, given a string, print it on screen with indentations,
    useful for generating comments and python code.

    :param stringVal: The string to be indented. If it is a multiline string then indent each line.
    :type stringVal:str

    :param indent: Indent type. Can be tabs space etc.
    :type indent: str

    :return: None

    """
    stringList=stringVal.split("\n")

    for idx,strng in enumerate(stringList):
        if not idx and len(stringList)==1:
            print("%s%s%s%s"%(indent,stringPrefix,strng,stringSuffix))
        elif not idx and len(stringList)>1:
            print("%s%s%s" % (indent, stringPrefix, strng))
        elif idx==len(stringList)-1:
            print("%s%s%s" % (indent, strng,stringSuffix))
        else:
            print("%s%s" % (indent, strng))

